

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <errno.h>

int read_exactly(int fd, void *buf, size_t count)
{
	size_t to_read = count, n;
	do {
		n = read(fd, buf, to_read);
		if (n == -1) {
			if (errno==EINTR) {
				/* Si le read a été interrompu par un signal,
				   on reprend le read */
				continue;
			}
			/* Un autre problème est survenu, on le signal
			 * en quittant cette fonction */
                        return n;
		}
		if (n == 0) {
			/* On est à la fin du fichier alors qu'on veut
			 * encore lire des données ! */
			return count-to_read;
		}
                buf += n;
                to_read -= n;
		/* Si on n'a pas tout lu ce qu'on voulait, on continue */
        } while(to_read);

	return count;
}


int main()
{
	int fd;

	fd=open("data1", O_RDONLY);
	if (fd==-1) {
		perror("Impossible d'ouvrir le fichier 'data1' en lecture ");
		exit(1);
	}
	
	for(;;) {
		int val;
		int nb_read=read_exactly(fd, &val, sizeof(int));

		
		if (nb_read == -1) {
			perror("Erreur de lecture ");
			exit(1);
		}
		if (nb_read == 0) {
			printf("Fin du fichier\n");
			break;
		}
		if (nb_read != sizeof(int)) {
			printf("Fin du fichier prématurée !\n");
			break;
		}
		printf("Je viens de lire : %d\n", val);
	}

	close(fd);
	return 0;
}

